package com.microservices.system.service;

import com.microservices.common.core.web.domain.AjaxResult;
import com.microservices.system.api.domain.SysDept;
import com.microservices.system.api.domain.SysRole;
import com.microservices.system.domain.vo.SysRoleInputVo;

import java.util.List;

/**
 * 部门下可选角色Service接口
 *
 * @author otto
 * @date 2023-04-12
 */
public interface ISysDeptRoleService {
    /**
     * 获取部门下可选角色列表
     *
     * @param deptId   部门主键
     * @param roleName
     * @return 角色信息
     */
    List<SysRole> selectSysRoleListByDept(Long deptId, String roleName);

    /**
     * 批量增加部门下可选角色
     *
     * @param deptId  部门主键
     * @param roleIds 角色主键列表
     * @return 结果
     */
    boolean addSysRoleListForSysDept(Long deptId, Long[] roleIds);

    /**
     * 批量删除部门下可选角色
     *
     * @param deptId  部门主键
     * @param roleIds 角色主键列表
     * @return 结果
     */
    int deleteSysRoleListForSysDept(Long deptId, Long[] roleIds);

    /**
     * 检查部门下是否包含该角色
     *
     * @param deptId 部门id
     * @param roleId 角色id列表
     * @return
     */
    boolean checkDeptHasRole(Long deptId, Long roleId);

    /**
     * 通过组织Id检查组织是否存在，不存在则抛出异常
     *
     * @param deptId 组织Id
     * @return
     */
    public SysDept selectSysDeptById(Long deptId);

    /**
     * 查询所有角色列表
     *
     * @return 角色列表
     */
    List<SysRole> selectSysRoleList();

    void addSysRoleForSysDept(Long currentDeptId, Long roleId);

    Boolean isDefaultRole(String roleKey);

    /**
     * 根据菜单列表获取角色数据权限
     *
     * @param menuIds 菜单Id列表
     * @return 数据权限
     */
    String getRoleDataScopeRole(Long[] menuIds);

    /**
     * 在组织下生成随机的唯一角色标识
     *
     * @param deptId 组织Id
     * @return 角色标识
     */
    String genRoleKeyByDeptId(Long deptId);

    /**
     * 检查组织下是否存在该角色名称
     *
     * @param deptId   组织Id
     * @param roleName 角色名称
     * @return 是否存在
     */
    void checkDeptHasRoleName(Long deptId, String roleName);

    /**
     * 新增角色
     *
     * @param deptId    组织Id
     * @param roleInput 角色输入对象
     * @return 操作结果
     */
    int addSysRole(Long deptId, SysRoleInputVo roleInput);

    /**
     * 更新角色
     *
     * @param deptId  组织Id
     * @param sysRole 角色更新对象
     * @return 更新结果
     */
    int updateSysRole(Long deptId, SysRole sysRole);

    /**
     * 查看角色对应菜单列表树
     *
     * @param currentDeptId 组织id
     * @param roleId        角色id
     * @return 结果
     */
    AjaxResult roleMenuTreeSelect(Long currentDeptId, Long roleId);
}
